using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.Drawing.Imaging;
using System.Runtime.InteropServices;

namespace GDIPlusErrorTest
{
    /// <summary>
    /// Created by Kerry Wong
    /// http://www.kerrywong.com
    /// http://support.microsoft.com/?id=814675
    /// </summary>
    class Program
    {
        private string fileName = @"c:\temp\test.bmp";

        public void Test()
        {
            Image img = Image.FromFile(fileName);
            try
            {
                img.Save(fileName); //throws exception!
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
            }
        }

        public void Method1() 
        {
            Image img = Image.FromFile(fileName);
            Bitmap bmp = img as Bitmap;
            Graphics g = Graphics.FromImage(bmp);
            Bitmap bmpNew = new Bitmap(bmp);
            g.DrawImage(bmpNew, new Point(0, 0));
            g.Dispose();
            bmp.Dispose();
            img.Dispose();

            //code to manipulate bmpNew goes here.

            bmpNew.Save(fileName);
        }

        public void Method2()
        {
            Image img = Image.FromFile(fileName);
            Bitmap bmp = img as Bitmap;

            BitmapData bmpData = bmp.LockBits(new Rectangle(0, 0, img.Width, img.Height), ImageLockMode.ReadWrite, bmp.PixelFormat);

            int byteCount = bmpData.Stride * bmpData.Height;
            byte[] bytes = new byte[byteCount];

            Marshal.Copy(bmpData.Scan0,  bytes,0, byteCount);
            bmp.UnlockBits(bmpData);

            Bitmap bmpNew = new Bitmap(bmp.Width, bmp.Height);
            BitmapData bmpData1 = bmpNew.LockBits(new Rectangle(new Point(), bmpNew.Size), ImageLockMode.ReadWrite, bmp.PixelFormat);
            Marshal.Copy(bytes, 0, bmpData1.Scan0, bytes.Length);
            bmpNew.UnlockBits(bmpData1);
            bmp.Dispose();

            //code to manipulate bmpNew goes here.
            bmpNew.Save(fileName);
        }

        static void Main(string[] args)
        {
            Program p = new Program();
            p.Test();
            p.Method1();
            p.Method2();
        }
    }
}
